require './lib/praetor/service_client'
require './lib/praetor/service'
require './spec/support/echo_service/service'

RSpec.describe Praetor::ServiceClient do
  let(:client) { Praetor::ServiceClient.new 'echo_service' }
  before { Thread.new { EchoService.new.run } }
  after { client.stop_service }

  it 'can call an action on the service' do
    response = client.request('echo#echo', 'hi there')
    expect(response).to eq 'hi there'

    response = client.request('double_echo#echo', 'hi')
    expect(response).to eq 'hihi'
  end

  it 'propagates exceptions raised in the service' do
    expect { client.request('echo#nope') }.to raise_error
  end
end
