require 'active_model'
require 'active_model_serializers'
require './lib/praetor/service_controller'

class SomeModel
  include ActiveModel::Model
  include ActiveModel::Serialization
  attr_accessor :id
end

class SomeModelSerializer < ActiveModel::Serializer
  attributes :id
end

class SomeController
  include Praetor::ServiceController
end

RSpec.describe Praetor::ServiceController do
  subject { SomeController.new }

  it 'serializes collections' do
    collection = 3.times.map { |i| SomeModel.new(id: i) }
    expect(subject.serialize_collection(collection)).to eq [{id: 0}, {id: 1}, {id: 2}]
  end

  it 'serializes resources' do
    resource = SomeModel.new(id: 0)
    expect(subject.serialize(resource)).to eq({ id: 0 })
  end
end

